#!/usr/bin/perl

package Modules::Zine::IndexGrid;

=pod

=head1 Modules::Zine::IndexGrid

=cut

use strict;
use ExSite::Config;
use Modules::Zine::Index;

use vars qw(@ISA);
@ISA = qw(Modules::Zine::Index);

sub index {
    my ($this,%opt) = @_;

    # get all the articles in the index
    my @articles = $this->fetch_index(%opt);

    # format the index
    return $this->index_grid(\%opt,@articles);
}

# A grid gallery indexes a zine using its photos

sub index_grid {
    my ($this,$opt,@art) = @_;
    my $ml = &get_obj("ML");
    my $out;
    my $n = 0;
    my $gwidth = $this->{config}{gallery_width} || 4;
    if (@art > 0) {
	$this->save;
	my $row;
	foreach my $art (@art) {
	    next if ($art->{type} eq "comment" and $opt->{mode} eq "article");
	    next if ($art->{type} ne "comment" and $opt->{mode} ne "article");
	    $this->set($art);
	    if ($opt->{age} >= 0 && ($this->age > $opt->{age})) {
		$this->{narch}++;
		next;
		#last;
	    }
	    my $thumb = $this->thumb || 
		$ml->img(undef,{src=>"$config{server}{HTMLpath}/_Modules/Zine/nophoto.gif", height=>50, width=>50, border=>0}); 
	    my $url = $this->link(zine=>"show",aid=>$this->{article_id});
	    $row .= $ml->td($ml->a($thumb,{href=>$url}),{align=>"center", class=>"ZineThumb"});
	    $n++;
	    if ($n == $opt->{limit}) {
		$this->{narch}++;
		last;
	    }
	    if (($n % $gwidth) == 0) {
		$out .= $ml->tr($row);
		$row = undef;
	    }
	}
	foreach (1.. ((scalar @art) % $gwidth)) {
	    $row .= $ml->td(undef,{class=>"ZineThumb"});
	}
	if (length $row) { $out .= $ml->tr($row); }
	$this->restore;
    }
    if ($out) {
	$out = $ml->table($out,{class=>"ZineIndex"});
    }

    return $out;
}

1;

